## python3.5 3.5.2

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python
SPHINXBUILD  = sphinx-build
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/extensions/patchlevel.py)

ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees -D latex_paper_size=$(PAPER) \
                $(SPHINXOPTS) . build/$(BUILDER) $(SOURCES)

.PHONY: help build html htmlhelp latex text changes linkcheck \
	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
	autobuild-dev autobuild-stable venv

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  venv       to create a venv with necessary tools"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlview   to open the index page built by the html target in your browser"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  suspicious to check for suspicious markup in output text"
	@echo "  check      to run a check for frequent markup errors"
	@echo "  serve      to serve the documentation on the localhost (8000)"

build:
	$(SPHINXBUILD) $(ALLSPHINXOPTS)
	@echo

html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

linkcheck: BUILDER = linkcheck
linkcheck:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Link check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/output.txt"; \
	false; }

suspicious: BUILDER = suspicious
suspicious:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Suspicious check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
	     "positives, append that file to tools/susp-ignored.csv."; \
	false; }

coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

doctest: BUILDER = doctest
doctest:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Testing of doctests in the sources finished, look at the" \
	     "results in build/doctest/output.txt"; \
	false; }

pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now run this:" \
	      "cp build/pydoc-topics/topics.py ../Lib/pydoc_data/topics.py"

htmlview: html
	 $(PYTHON) -c "import webbrowser; webbrowser.open('build/html/index.html')"

clean:
	-rm -rf build/* venv/*

venv:
	$(PYTHON) -m venv venv
	./venv/bin/python3 -m pip install -U Sphinx

dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

	# copy the epub build
	rm -rf build/epub
	make epub
	cp -pPR build/epub/Python.epub dist/python-$(DISTVERSION)-docs.epub

check:
	$(PYTHON) tools/rstlint.py -i tools

serve:
	../Tools/scripts/serve.py build/html

# Targets for daily automated doc build

# for development releases: always build
autobuild-dev:
	make dist SPHINXOPTS='-A daily=1 -A versionswitcher=1'
	-make suspicious

# for quick rebuilds (HTML only)
autobuild-html:
	make html SPHINXOPTS='-A daily=1 -A versionswitcher=1'

# for stable releases: only build if not in pre-release stage (alpha, beta)
# release candidate downloads are okay, since the stable tree can be in that stage
autobuild-stable:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

## python3.5 3.5.0

=== debian/changelog ===
python3.5 (3.5.0-3) unstable; urgency=medium

  * Update to 20151011 from the 3.5 branch.
    - Idle updates.
    - Issue #24402: Fix input() to prompt to the redirected stdout when
      sys.stdout.fileno() fails.
    - Issue #24806: Prevent builtin types that are not allowed to be subclassed
      from being subclassed through multiple inheritance.
    - Issue #24848: Fixed a number of bugs in UTF-7 decoding of misformed data.
    - Issue #25280: Import trace messages emitted in verbose (-v) mode are no
      longer formatted twice.
    - Issue #25003: On Solaris 11.3 or newer, os.urandom() now uses the
      getrandom() function instead of the getentropy() function. The getentropy()
      function is blocking to generate very good quality entropy, os.urandom()
      doesn't need such high-quality entropy.
    - Issue #25182: The stdprinter (used as sys.stderr before the io module is
      imported at startup) now uses the backslashreplace error handler.
    - Issue #25131: Make the line number and column offset of set/dict literals
      and comprehensions correspond to the opening brace.
    - Issue #25364: zipfile now works in threads disabled builds.
    - Issue #25328: smtpd's SMTPChannel now correctly raises a ValueError if
      both decode_data and enable_SMTPUTF8 are set to true.
    - Issue #25316: distutils raises OSError instead of DistutilsPlatformError
      when MSVC is not installed.
    - Issue #23972: Updates asyncio datagram create method allowing reuseport
      and reuseaddr socket options to be set prior to binding the socket.
      Mirroring the existing asyncio create_server method the reuseaddr option
      for datagram sockets defaults to True if the O/S is 'posix' (except if
      the platform is Cygwin).
    - Issue #25304: Add asyncio.run_coroutine_threadsafe().  This lets you
      submit a coroutine to a loop from another thread, returning a
      concurrent.futures.Future.
    - Issue #25232: Fix CGIRequestHandler to split the query from the URL at the
      first question mark (?) rather than the last.
    - Issue #24657: Prevent CGIRequestHandler from collapsing slashes in the
      query part of the URL as if it were a path.
    - Issue #24483: C implementation of functools.lru_cache() now calculates
      key's hash only once.
    - Issue #22958: Constructor and update method of weakref.WeakValueDictionary
      now accept the self and the dict keyword arguments.
    - Issue #22609: Constructor of collections.UserDict now accepts the self
      keyword argument.
    - Issue #25111: Fixed comparison of traceback.FrameSummary.
    - Issue #25262. Added support for BINBYTES8 opcode in Python implementation
      of unpickler.
    - Issue #25034: Fix string.Formatter problem with auto-numbering and
      nested format_specs.
    - Issue #25233: Rewrite the guts of asyncio.Queue and
      asyncio.Semaphore to be more understandable and correct.
    - Issue #25203: Failed readline.set_completer_delims() no longer left the
      module in inconsistent state.
    - Issue #23600: Default implementation of tzinfo.fromutc() was returning
      wrong results in some cases.
    - Issue #23329: Allow the ssl module to be built with older versions of
      LibreSSL.
    - Issue #25319: When threading.Event is reinitialized, the underlying
      condition should use a regular lock rather than a recursive lock.
    - Issue #25099: Make test_compileall not fail when a entry on sys.path
      cannot be written to.
    - Issue #23919: Prevents assert dialogs appearing in the test suite.
  * Back-out the local patch for issue 21264, supposed to be fixed by #25099.
  * Adjust setting DH_COMPAT for dh_movefiles with updated debhelper supporting
    globbing of arguments. Closes: #800247.
  * pydoc: use the pager command if available. Addresses: #799555.

 -- Matthias Klose <doko@debian.org>  Sun, 11 Oct 2015 11:05:38 +0200

python3.5 (3.5.0-2) unstable; urgency=medium

  * Update to 20150924 from the 3.5 branch.
  * Expect the test_code_module test to fail in the autopkg tests.
    See upstream issue #25109.
  * Provide some user-friendly advice when `python3 -m venv` fails because the
    python3-venv package is not installed (Barry Warsaw).

 -- Matthias Klose <doko@debian.org>  Thu, 24 Sep 2015 01:01:34 +0200

python3.5 (3.5.0-1) unstable; urgency=medium

  * Python 3.5.0 release.
  * Drop the no-zip-on-sys.path patch; not worth saving, and the test suite
    needs adjustments ...
  * Mark the test_site test as failing. Investigate why this fails.
    The package has one sitedir less than expected.

 -- Matthias Klose <doko@debian.org>  Sun, 13 Sep 2015 16:38:26 +0200

python3.5 (3.5.0~rc3-1) unstable; urgency=medium

  * Python 3.5.0 release candidate 3.

 -- Matthias Klose <doko@debian.org>  Tue, 08 Sep 2015 09:56:15 +0200

python3.5 (3.5.0~rc2-1) unstable; urgency=medium

  * Python 3.5.0 release candidate 2.

 -- Matthias Klose <doko@debian.org>  Tue, 25 Aug 2015 22:29:07 +0200

python3.5 (3.5.0~rc1-1) unstable; urgency=medium

  * Python 3.5.0 release candidate 1.
  * Update symbols file.

 -- Matthias Klose <doko@debian.org>  Wed, 12 Aug 2015 16:57:46 +0200

python3.5 (3.5.0~b4-1) unstable; urgency=medium

  * Python 3.5.0 beta 4.

 -- Matthias Klose <doko@debian.org>  Mon, 27 Jul 2015 12:27:48 +0200

python3.5 (3.5.0~b3-2) unstable; urgency=medium

  * Fix expansion of makefile macros for _sysconfigdata. Issue #24705.
    LP: #1477759.

 -- Matthias Klose <doko@debian.org>  Fri, 24 Jul 2015 15:25:23 +0200

python3.5 (3.5.0~b3-1) unstable; urgency=medium

  * Python 3.5.0 beta 3.

 -- Matthias Klose <doko@debian.org>  Mon, 06 Jul 2015 13:55:07 +0200

python3.5 (3.5.0~b2-1) unstable; urgency=medium

  * Python 3.5.0 beta 2.
  * Make the build reproducible (Jérémy Bobbio). Closes: #786959.
    - Pass time of latest debian/changelog entry to sphinx via SPHINXOPTS.
    - Do not store a timestamps when compressing devhelp.


=== debian/control ===
Source: python3.5
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 5.0.51~), dpkg-dev (>= 1.17.11),
  quilt, autoconf,
  lsb-release, sharutils,
  libreadline6-dev, libncursesw5-dev (>= 5.3), gcc (>= 4:4.9.2),
  zlib1g-dev, libbz2-dev, liblzma-dev,
  libgdbm-dev, libdb-dev,
  tk-dev, blt-dev (>= 2.4z), libssl-dev,
  libexpat1-dev, libmpdec-dev (>= 2.4),
  libbluetooth-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  locales [!armel !avr32 !hppa !ia64 !mipsel],
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
  libgpm2 [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  mime-support, netbase, bzip2, python3:any,
  net-tools, xvfb, xauth
Build-Depends-Indep: python-sphinx
Standards-Version: 3.9.6
Vcs-Browser: https://code.launchpad.net/~doko/python/pkg3.5-debian
Vcs-Bzr: http://bazaar.launchpad.net/~doko/python/pkg3.5-debian
XS-Testsuite: autopkgtest

Package: python3.5
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.5-minimal (= ${binary:Version}), libpython3.5-stdlib (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Suggests: python3.5-venv, python3.5-doc, binutils
Description: Interactive high-level object-oriented language (version 3.5)
 Python is a high-level, interactive, object-oriented language. Its 3.5 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.5-venv
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.5 (= ${binary:Version}),
 python-setuptools-whl, python-pip-whl, ${shlibs:Depends}, ${misc:Depends}
Breaks: python3-pip (<< 1.5.6-4)
Description: Interactive high-level object-oriented language (pyvenv binary, version 3.5)
 Python is a high-level, interactive, object-oriented language. Its 3.5 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the pyvenv-3.5 binary.

Package: libpython3.5-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.5-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Description: Interactive high-level object-oriented language (standard library, version 3.5)
 Python is a high-level, interactive, object-oriented language. Its 3.5 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 3.5's standard library. It is normally not
 used on its own, but as a dependency of python3.5.

Package: python3.5-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython3.5-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.5
Suggests: binfmt-support
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.5)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.5-minimal/README.Debian for a list of the modules
 contained in this package.

Package: libpython3.5-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython3.5-stdlib
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.5)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python3.5-minimal.

Package: libpython3.5
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.5-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Shared Python runtime library (version 3.5)
 Python is a high-level, interactive, object-oriented language. Its 3.5 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.5-examples
Architecture: all
Depends: python3.5 (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v3.5)
 Examples, Demos and Tools for Python (v3.5). These are files included in
 the upstream Python distribution (v3.5).

Package: python3.5-dev
Architecture: any
Multi-Arch: allowed
Depends: python3.5 (= ${binary:Version}), libpython3.5-dev (= ${binary:Version}), libpython3.5 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.5)
 Header files, a static library and development tools for building
 Python (v3.5) modules, extending the Python interpreter or embedding
 Python (v3.5) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython3.5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.5-stdlib (= ${binary:Version}), libpython3.5 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.5)
 Header files, a static library and development tools for building
 Python (v3.5) modules, extending the Python interpreter or embedding
 Python (v3.5) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python3.5-dev.

Package: libpython3.5-testsuite
Section: libdevel
Architecture: all
Depends: python3.5 (>= ${binary:Version}), ${misc:Depends}, net-tools
Suggests: python3-gdbm, python3-tk
Description: Testsuite for the Python standard library (v3.5)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython3.5-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython3.5-stdlib package).

Package: idle-python3.5
Architecture: all
Depends: python3.5, python3-tk, python3.5-tk, ${misc:Depends}
Enhances: python3.5
Description: IDE for Python (v3.5) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.5).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.5-doc
Section: doc
Architecture: all
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.5
Description: Documentation for the high-level object-oriented language Python (v3.5)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.5). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.5
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.5-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Priority: extra
Depends: python3.5 (= ${binary:Version}), libpython3.5-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.5)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython3.5-dbg
Section: debug
Architecture: any
Multi-Arch: same
Priority: extra
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.5-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Debug Build of the Python Interpreter (version 3.5)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

=== debian/rules ===
#!/usr/bin/make -f

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt		= $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS	:= $(shell dpkg-architecture)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

CHANGELOG_VARS := $(shell dpkg-parsechangelog | \
	sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE  := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)

LAST_CHANGE := $(shell dpkg-parsechangelog -S Date)
export BUILD_DATE := $(shell LC_ALL=C date -u +'%b %e %Y' -d '$(LAST_CHANGE)')
export BUILD_TIME := $(shell LC_ALL=C date -u +'%H:%M:%S' -d '$(LAST_CHANGE)')

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_BENCH := yes
    WITHOUT_STONE := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
  WITHOUT_STONE := yes
endif

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)

VER=3.5
SVER=3.5.0~b1
NVER=3.6
PVER=python$(VER)
EXT_VER=$(subst .,,$(VER))
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  with_fpectl = yes
  #with_udeb = yes
else
  PY_MINPRIO = $(PY_PRIO)
  with_fpectl = yes
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifneq (,$(filter $(distrelease),sid experimental))
  bd_gcc = gcc (>= 4:4.9.2),
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif

CC=$(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

DPKG_CPPFLAGS:= $(shell dpkg-buildflags --get CPPFLAGS)
DPKG_CFLAGS  := $(shell dpkg-buildflags --get CFLAGS)
DPKG_LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))

# on alpha, use -O2 only, use -mieee
ifeq ($(DEB_HOST_ARCH),alpha)
    OPT_CFLAGS += -mieee
    DEBUG_CFLAGS += -mieee
    EXTRA_OPT_FLAGS += -O2
endif
ifeq ($(DEB_HOST_ARCH),m68k)
    EXTRA_OPT_FLAGS += -O2
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el))
      with_pgo := yes
    endif
  endif
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el))
  with_lto := yes
endif

ifeq ($(distribution),Debian)
    # FIXME: investigate, succeeds locally
    # https://buildd.debian.org/status/fetch.php?pkg=python3.5&arch=i386&ver=3.5.0%7Ea4-3&stamp=1431890568
    with_pgo :=
endif
ifeq ($(distribution),Ubuntu)
    # FIXME
    ifneq (,$(findstring $(DEB_HOST_ARCH), i386))
      with_pgo :=
    endif
endif

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
    EXTRA_OPT_CFLAGS = -O0
    with_pgo =
    with_lto =
endif

ifeq ($(with_lto),yes)
    LTO_CFLAGS = -g -flto -fuse-linker-plugin
    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
    ifeq ($(with_fat_lto),yes)
      LTO_CFLAGS += -ffat-lto-objects
    endif
    EXTRA_OPT_CFLAGS += $(LTO_CFLAGS)
    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
endif

make_build_target = $(if $(with_pgo),profile-opt)

buildd_static	:= $(CURDIR)/build-static
buildd_shared	:= $(CURDIR)/build-shared
buildd_debug	:= $(CURDIR)/build-debug
buildd_shdebug	:= $(CURDIR)/build-shdebug

d		:= debian/tmp
scriptdir	=  usr/share/lib/python$(VER)
scriptdir	=  usr/share/python$(VER)
scriptdir	=  usr/lib/python$(VER)

# package names and directories
p_base	:= $(PVER)
p_min	:= $(PVER)-minimal
p_lib	:= lib$(PVER)
p_tk	:= $(PVER)-tk
p_dev	:= $(PVER)-dev
p_exam	:= $(PVER)-examples
p_idle	:= idle-$(PVER)
p_doc	:= $(PVER)-doc
p_dbg	:= $(PVER)-dbg
p_udeb	:= $(PVER)-udeb
p_venv	:= $(PVER)-venv

p_lbase	:= lib$(PVER)-stdlib
p_lmin	:= lib$(PVER)-minimal
p_ldev	:= lib$(PVER)-dev
p_ldbg	:= lib$(PVER)-dbg
p_ltst	:= lib$(PVER)-testsuite

d_base	:= debian/$(p_base)
d_min	:= debian/$(p_min)
d_lib	:= debian/$(p_lib)
d_tk	:= debian/$(p_tk)
d_dev	:= debian/$(p_dev)
d_exam	:= debian/$(p_exam)
d_idle	:= debian/$(p_idle)
d_doc	:= debian/$(p_doc)
d_dbg	:= debian/$(p_dbg)
d_udeb	:= debian/$(p_udeb)
d_venv	:= debian/$(p_venv)

d_lbase	:= debian/$(p_lbase)
d_lmin	:= debian/$(p_lmin)
d_ldev	:= debian/$(p_ldev)
d_ldbg	:= debian/$(p_ldbg)
d_ltst	:= debian/$(p_ltst)

build-arch: stamps/stamp-build
build-indep: stamps/stamp-build-doc
build: build-arch
stamps/stamp-build: stamps/stamp-build-static stamps/stamp-mincheck \
    stamps/stamp-build-shared stamps/stamp-build-debug \
    stamps/stamp-build-shared-debug \
    stamps/stamp-check stamps/stamp-pystone stamps/stamp-pybench
	touch $@

PROFILE_EXCLUDES = test_compiler test_distutils test_subprocess \

## python3.5 3.5.1

=== debian/changelog ===
python3.5 (3.5.1-10) unstable; urgency=medium

  * Update to 20160330 from the 3.5 branch.

 -- Matthias Klose <doko@debian.org>  Thu, 31 Mar 2016 00:46:26 +0200

python3.5 (3.5.1-9) unstable; urgency=medium

  * Update to 20160323 from the 3.5 branch.
  * Always build _math.o with -fPIC.

 -- Matthias Klose <doko@debian.org>  Wed, 23 Mar 2016 11:47:21 +0100

python3.5 (3.5.1-8) unstable; urgency=medium

  * Update to 20160318 from the 3.5 branch.
  * Fix python3-venv with updated python-pip packages (Barry Warsaw).
    Closes: #815014, #815864.
  * Fix generating devhelp documentation (Simon McVittie).
    Closes: #816299. LP: #1553633.

 -- Matthias Klose <doko@debian.org>  Fri, 18 Mar 2016 16:12:19 +0100

python3.5 (3.5.1-7) unstable; urgency=medium

  * Update to 20160224 from the 3.5 branch.
  * python3.5-venv: Drop the dependency on python-setuptools-whl,
    depend on python-pip-whl (>= 8.0.2-7).
  * Don't run the test_socket test, hangs on some buildds.

 -- Matthias Klose <doko@debian.org>  Wed, 24 Feb 2016 12:28:57 +0100

python3.5 (3.5.1-6) unstable; urgency=medium

  * Update to 20160221 from the 3.5 branch.

 -- Matthias Klose <doko@debian.org>  Mon, 22 Feb 2016 00:11:32 +0100

python3.5 (3.5.1-5) unstable; urgency=medium

  * Update to 20160113 from the 3.5 branch.

 -- Matthias Klose <doko@debian.org>  Wed, 13 Jan 2016 16:09:18 +0100

python3.5 (3.5.1-4) unstable; urgency=medium

  * Update to 20160111 from the 3.5 branch.

 -- Matthias Klose <doko@debian.org>  Mon, 11 Jan 2016 21:50:55 +0100

python3.5 (3.5.1-3) unstable; urgency=medium

  * Update to 20160105 from the 3.5 branch.
  * Fix maintainer scripts with findutils 4.6. Closes: #809079.

 -- Matthias Klose <doko@debian.org>  Tue, 05 Jan 2016 12:13:30 +0100

python3.5 (3.5.1-2) unstable; urgency=medium

  * Disable LTO on Debian/s390x.
  * Don't run test_signal on alpha, currently breaks the testsuite.

 -- Matthias Klose <doko@debian.org>  Thu, 10 Dec 2015 15:34:41 +0100

python3.5 (3.5.1-1) unstable; urgency=medium

  * Python 3.5.1 release.
  * Fix building architecture independent packages only. Closes: #806870.
  * Update symbols files for i386.
  * d/p/fix-sslv3-test.diff: properly handle Ubuntu's openssl having OP_NO_SSLv3
    forced on by default (Marc Deslauriers).

 -- Matthias Klose <doko@debian.org>  Mon, 07 Dec 2015 11:34:52 +0100

python3.5 (3.5.1~rc1-2) unstable; urgency=medium

  * Build-depend on time.

 -- Matthias Klose <doko@debian.org>  Tue, 24 Nov 2015 08:26:06 +0100

python3.5 (3.5.1~rc1-1) unstable; urgency=medium

  * Python 3.5.1 release candidate 1.
  * Don't ship menu files anymore, just desktop files.
  * Update symbols file.

 -- Matthias Klose <doko@debian.org>  Mon, 23 Nov 2015 22:10:38 +0100

python3.5 (3.5.0-4) unstable; urgency=medium

  * Update to 20151028 from the 3.5 branch.
    - Issue #25274: sys.setrecursionlimit() now raises a RecursionError if the
      new recursion limit is too low depending at the current recursion depth.
      Modify also the "lower-water mark" formula to make it monotonic. This mark
      is used to decide when the overflowed flag of the thread state is reset.
    - Issue #25447: The lru_cache() wrapper objects now can be copied and
      pickled (by returning the original object unchanged).
    - Issue #25390: typing: Don't crash on Union[str, Pattern].
    - Issue #25441: asyncio: Raise error from drain() when socket is closed.
    - Issue #25410: Cleaned up and fixed minor bugs in C implementation of
      OrderedDict.
    - Issue #25411: Improved Unicode support in SMTPHandler through better use
      of the email package.
    - Issue #25407: Remove mentions of the formatter module being removed in
      Python 3.6.
    - Issue #25406: Fixed a bug in C implementation of OrderedDict.move_to_end()
      that caused segmentation fault or hang in iterating after moving several
      items to the start of ordered dict.
    - Issue #25380: Fixed protocol for the STACK_GLOBAL opcode in
      pickletools.opcodes.
    - Issue #25471: Sockets returned from accept() shouldn't appear to be
      nonblocking.
    - Issue #25440: Fix output of python-config --extension-suffix.

 -- Matthias Klose <doko@debian.org>  Wed, 28 Oct 2015 16:31:37 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: python
 Priority: optional
 Maintainer: Matthias Klose <doko@debian.org>
-Build-Depends: debhelper (>= 5.0.51~), dpkg-dev (>= 1.17.11),
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11),
   quilt, autoconf,
   lsb-release, sharutils,
-  libreadline6-dev, libncursesw5-dev (>= 5.3), gcc (>= 4:4.9.2),
+  libreadline-dev, libncursesw5-dev (>= 5.3), 
   zlib1g-dev, libbz2-dev, liblzma-dev,
   libgdbm-dev, libdb-dev,
   tk-dev, blt-dev (>= 2.4z), libssl-dev,
@@ -14,7 +14,7 @@
   locales [!armel !avr32 !hppa !ia64 !mipsel],
   libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
   libgpm2 [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
-  mime-support, netbase, bzip2, python3:any,
+  mime-support, netbase, bzip2, time, python3:any,
   net-tools, xvfb, xauth
 Build-Depends-Indep: python-sphinx
 Standards-Version: 3.9.6
@@ -38,7 +38,7 @@
 Multi-Arch: allowed
 Priority: optional
 Depends: python3.5 (= ${binary:Version}),
- python-setuptools-whl, python-pip-whl, ${shlibs:Depends}, ${misc:Depends}
+ python-pip-whl (>= 8.1.0-2), ${shlibs:Depends}, ${misc:Depends},
 Breaks: python3-pip (<< 1.5.6-4)
 Description: Interactive high-level object-oriented language (pyvenv binary, version 3.5)
  Python is a high-level, interactive, object-oriented language. Its 3.5 version
@@ -53,6 +53,7 @@
 Priority: optional
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libpython3.5-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
+Breaks: libmpdec2 (<< 2.4.2)
 Description: Interactive high-level object-oriented language (standard library, version 3.5)
  Python is a high-level, interactive, object-oriented language. Its 3.5 version
  includes an extensive class library with lots of goodies for

=== debian/rules ===
--- 
+++ 
@@ -56,6 +56,8 @@
   WITHOUT_CHECK := yes
   WITHOUT_STONE := yes
 endif
+  WITHOUT_CHECK := yes
+  WITHOUT_BENCH := yes
 
 COMMA = ,
 ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
@@ -125,7 +127,7 @@
   ma_filter = grep -v '^Multi-Arch:'
 endif
 ifneq (,$(filter $(distrelease),sid experimental))
-  bd_gcc = gcc (>= 4:4.9.2),
+  bd_gcc = gcc-5 (>= 5.3.1),
 endif
 ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
   bd_dpkgdev = dpkg-dev (>= 1.17.11),
@@ -155,26 +157,19 @@
 
 ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
   ifeq ($(DEB_HOST_ARCH_OS),linux)
-    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el))
+    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
       with_pgo := yes
     endif
   endif
 endif
 
-ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el))
+ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
   with_lto := yes
 endif
 
 ifeq ($(distribution),Debian)
-    # FIXME: investigate, succeeds locally
-    # https://buildd.debian.org/status/fetch.php?pkg=python3.5&arch=i386&ver=3.5.0%7Ea4-3&stamp=1431890568
-    with_pgo :=
-endif
-ifeq ($(distribution),Ubuntu)
-    # FIXME
-    ifneq (,$(findstring $(DEB_HOST_ARCH), i386))
-      with_pgo :=
-    endif
+  # FIXME: https://buildd.debian.org/status/logs.php?pkg=python3.5&ver=3.5.1-1&arch=s390x&suite=sid
+  with_lto := $(if $(filter $(DEB_HOST_ARCH), s390x),,$(with_lto))
 endif
 
 ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
@@ -255,3 +250,4 @@
 	touch $@
 
 PROFILE_EXCLUDES = test_compiler test_distutils test_subprocess \
+	test_multiprocessing test_socket test_socketserver \

## python3.5 3.5.2

=== debian/changelog ===
python3.5 (3.5.2-2ubuntu0~16.04.4~14.04.1) trusty; urgency=medium

  * Backport python3.5 to trusty for building Firefox

  * Don't perform a PGO build, as it causes crashes during the build
  * Drop the libpython3.5-stdlib Breaks on libmpdec2 (<< 2.4.2), as this
    doesn't appear to be needed. Python 3.5 and 3.4 are both bundled with the
    same version, and trusty's Python 3.4 is already built against and using
    2.4.0

 -- Chris Coulson <chris.coulson@canonical.com>  Tue, 03 Apr 2018 20:16:03 +0100

python3.5 (3.5.2-2ubuntu0~16.04.4) xenial-security; urgency=medium

  * SECURITY UPDATE: integer overflow in the PyBytes_DecodeEscape
    function
    - debian/patches/CVE-2017-1000158.patch: fix this integer overflow
      in Objects/bytesobject.c.
    - CVE-2017-1000158

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Thu, 23 Nov 2017 13:37:01 -0300

python3.5 (3.5.2-2ubuntu0~16.04.3) xenial; urgency=medium

  * Explicitly use the system python for byte compilation in postinst scripts.
    (LP: #1682934)

 -- Brian Murray <brian@ubuntu.com>  Thu, 14 Sep 2017 15:51:06 -0700

python3.5 (3.5.2-2ubuntu0~16.04.2) xenial; urgency=medium

  * SRU: LP: #1711724 Fix dict segfault. Issue #27945.

 -- Clint Byrum <clint@ubuntu.com>  Fri, 18 Aug 2017 10:48:00 -0700

python3.5 (3.5.2-2ubuntu0~16.04.1) xenial-security; urgency=medium

  * SECURITY UPDATE: use of HTTP_PROXY flag supplied by attacker in CGI
    scripts (aka HTTPOXY attack)
    - debian/patches/CVE-2016-1000110.patch: if running as CGI
      script, forget HTTP_PROXY in Lib/urllib.py, add test to
      Lib/test/test_urllib.py, add documentation.
    - CVE-2016-1000110
  * NOTE: backport of 3.5.2 to Ubuntu 16.04 LTS also addresses:
    - CVE-2016-0772: StartTLS stripping attack
    - CVE-2016-5636: Integer overflow when handling zipfiles

 -- Steve Beattie <sbeattie@ubuntu.com>  Thu, 17 Nov 2016 09:05:23 -0800

python3.5 (3.5.2-2~16.04) xenial-proposed; urgency=medium

  * SRU: LP: #1620754: Fix invalid code in pyhash/siphash24. Issue #28055.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 10 Sep 2016 10:21:44 +0200

python3.5 (3.5.2-2~16.01) xenial-proposed; urgency=medium

  * SRU: LP: #1591887. Backport 3.5.2 to 16.04 LTS.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 05 Jul 2016 14:43:10 +0200

python3.5 (3.5.2-2) unstable; urgency=medium

  * asyncio: Fix callbacks race in SelectorLoop.sock_connect, proposed patch
    taken from https://github.com/python/asyncio/pull/366.
  * asyncio: Fix NameError in asyncio.sslproto. Closes: #827453.

 -- Matthias Klose <doko@debian.org>  Tue, 05 Jul 2016 13:33:36 +0200

python3.5 (3.5.2-1) unstable; urgency=medium

  * Python 3.5.2 release.
    - Issue #26867: Ubuntu's openssl OP_NO_SSLv3 is forced on by default;
      fix test.
    - Issue #27365: Allow non-ascii in idlelib/NEWS.txt.

 -- Matthias Klose <doko@debian.org>  Mon, 27 Jun 2016 08:22:49 +0200

python3.5 (3.5.2~rc1-3) unstable; urgency=medium

  * Fix building with the wheel files in the source package.

 -- Matthias Klose <doko@debian.org>  Mon, 13 Jun 2016 11:33:26 +0200

python3.5 (3.5.2~rc1-1) unstable; urgency=medium

  * Python 3.5.2 release candidate 1.
    - Issue #15657: Delete incorrect statement from PyMethodDef documentation.
    - Issue #27289: Prevent test_urllib2net failures due to EOFError raised
      by ftplib.
    - Issue #25455: Clean up reference loops created in tests for recursive.
    - Issue #27190: Raise NotSupportedError if sqlite3 is older than 3.3.1.
    - Issue #27188: Fix various sqlite3 documentation errors.
    - Issue #15476: Make "code object" its own entry in the index.
    - Issue #8491: Add link to Gnu Readline configuration documentation.
    - Issue #24617: Add comment for os.mkdir about mode quirks.
    - Issue #27280: Fix typo in IPv6Network documentation.
    - Issue #17500, and https://github.com/python/pythondotorg/issues/945:
      Remove unused and outdated icons.
    - Issue #20900: distutils register command now decodes HTTP responses
      correctly.
    - Issue #5124: Paste with selection should always replace.
      This is how paste work on Windows, Mac, modern Linux apps, and ttk
      widgets.  The exception was X11 tk widgets.
    - Issue #27223: aio: Fix _read_ready and _write_ready to respect _conn_lost.
    - Issue #22970: asyncio: Fix inconsistency cancelling Condition.wait.
    - Issue #22558: Add remaining doc links to source code for Python-coded
      modules.
    - Issue #21386: Implement missing IPv4Address.is_global property.
    - Issue #27194: superfluous truncate calls in tarfile.py slow down
      extraction.
    - Issue #14209: pkgutil.iter_zipimport_modules ignores the prefix for
      packages.
    - Issue #24136: Document generalized unpacking, PEP 448.
    - Issue #27286: Fixed compiling BUILD_MAP_UNPACK_WITH_CALL opcode.  Calling
      function with generalized unpacking (PEP 448) and conflicting keyword
      names could cause undefined behavior.
    - Issue #25455: Fixed a crash in repr of ElementTree.Element with recursive
      tag.
  * Extend debian/copyright to the files shipped in the wheel files.

 -- Matthias Klose <doko@debian.org>  Mon, 13 Jun 2016 07:58:29 +0200

python3.5 (3.5.1-16) unstable; urgency=high

  * Restore the distutils-init patch, only applied on upstream trunk.

 -- Matthias Klose <doko@debian.org>  Fri, 10 Jun 2016 11:03:40 +0200

python3.5 (3.5.1-15) unstable; urgency=high

  * Fix bad update of the distutils-install-layout patch.

 -- Matthias Klose <doko@debian.org>  Fri, 10 Jun 2016 00:38:59 +0200

python3.5 (3.5.1-14) unstable; urgency=medium

  * Update to 20160609 from the 3.5 branch.
    - A new version of typing.py provides several new classes and
      features: @overload outside stubs, Reversible, DefaultDict, Text,
      ContextManager, Type[], NewType(), TYPE_CHECKING, and numerous bug
      fixes (note that some of the new features are not yet implemented in


=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: python3.5
 Section: python
 Priority: optional
-Maintainer: Matthias Klose <doko@debian.org>
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11),
+Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
+Build-Depends: debhelper (>= 9), 
   quilt, autoconf,
   lsb-release, sharutils,
   libreadline-dev, libncursesw5-dev (>= 5.3), 
@@ -17,7 +18,7 @@
   mime-support, netbase, bzip2, time, python3:any,
   net-tools, xvfb, xauth
 Build-Depends-Indep: python-sphinx
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Browser: https://code.launchpad.net/~doko/python/pkg3.5-debian
 Vcs-Bzr: http://bazaar.launchpad.net/~doko/python/pkg3.5-debian
 XS-Testsuite: autopkgtest
@@ -53,7 +54,6 @@
 Priority: optional
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libpython3.5-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
-Breaks: libmpdec2 (<< 2.4.2)
 Description: Interactive high-level object-oriented language (standard library, version 3.5)
  Python is a high-level, interactive, object-oriented language. Its 3.5 version
  includes an extensive class library with lots of goodies for

=== debian/rules ===
--- 
+++ 
@@ -127,7 +127,7 @@
   ma_filter = grep -v '^Multi-Arch:'
 endif
 ifneq (,$(filter $(distrelease),sid experimental))
-  bd_gcc = gcc-5 (>= 5.3.1),
+  bd_gcc =
 endif
 ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
   bd_dpkgdev = dpkg-dev (>= 1.17.11),
@@ -190,6 +190,8 @@
     AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
     RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
 endif
+
+with_pgo := 
 
 make_build_target = $(if $(with_pgo),profile-opt)
 
@@ -250,4 +252,4 @@
 	touch $@
 
 PROFILE_EXCLUDES = test_compiler test_distutils test_subprocess \
-	test_multiprocessing test_socket test_socketserver \
+	test_multiprocessing test_multiprocessing_fork \

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential, locales, python3.5-dev, libpython3.5-testsuite, python3-gdbm
# need to turn off apport
Restrictions: needs-root

Tests: testsuite-dbg
Depends: build-essential, locales, python3.5-dev, python3.5-dbg, libpython3.5-testsuite, python3-gdbm-dbg, gdb
# need to turn off apport
Restrictions: needs-root

Tests: failing-tests
Depends: build-essential, locales, python3.5-dev, libpython3.5-testsuite, python3-gdbm
# need to turn off apport
Restrictions: needs-root allow-stderr

Tests: failing-tests-dbg
Depends: build-essential, locales, python3.5-dev, python3.5-dbg, libpython3.5-testsuite, python3-gdbm-dbg, gdb
# need to turn off apport
Restrictions: needs-root allow-stderr
